unit aboutcom;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf, stdctrls;

type
  TAboutComponent1 = class(TComponent)
  private
    FAbout : String;
  public
    constructor Create(AOwner : TComponent); override;
  published
    property About : String read FAbout write FAbout;
  end;

  TAboutComponent2 = class(TEdit)
  private
    FAbout : String;
  public
    constructor Create(AOwner : TComponent); override;
  published
    property About : String read FAbout write FAbout;
  end;

procedure Register;

Const
  DefComponentVersion = '1.0';

implementation
uses compver;
{TAboutComponent1}
constructor TAboutComponent1.Create(AOwner : TComponent);
begin
  inherited;
  FAbout := 'Version';
end;

{TAboutComponent2}
constructor TAboutComponent2.Create(AOwner : TComponent);
begin
  inherited;
  FAbout := 'Version';
end;


{Create Component Editor}
type
  TComponentVersionEditor = class(TComponentEditor)
    procedure ExecuteVerb(Index: Integer); override;
    function GetVerb(Index: Integer): string; override;
    function GetVerbCount: Integer; override;
  end;

procedure TComponentVersionEditor.ExecuteVerb(Index: Integer);
begin
  case Index of
    0 : ShowComponentVersion(Component.ClassName, DefComponentVersion);
  end;
end;

function TComponentVersionEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Show version';
  end;
end;

function TComponentVersionEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

{Create property Editor}
type
TComponentVersionProperty = class(TStringProperty)
public
  procedure Edit; override;
  function GetAttributes: TPropertyAttributes; override;
end;

procedure TComponentVersionProperty.Edit;
begin
  ShowComponentVersion(GetComponent(0).ClassName, DefComponentVersion);
end;

function TComponentVersionProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog, paReadOnly];
end;



procedure Register;
begin
  RegisterComponents('RSDTIPS', [TAboutComponent1]);
  RegisterComponents('RSDTIPS', [TAboutComponent2]);  
  RegisterComponentEditor(TAboutComponent1, TComponentVersionEditor);
  RegisterComponentEditor(TAboutComponent2, TComponentVersionEditor);
  RegisterPropertyEditor(TypeInfo(String), TAboutComponent1, 'About', TComponentVersionProperty);
  RegisterPropertyEditor(TypeInfo(String), TAboutComponent2, 'About', TComponentVersionProperty);
end;

end.
